#import <OpenGL/CGLMacro.h>
#import "GLDepthBufferAlphaThreshold.h"

@implementation GLDepthBufferAlphaThreshold : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 1;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return YES;
}

+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	
	[inputThreshold setMinDoubleValue:0.0];
	[inputThreshold setMaxDoubleValue:1.0];

	return z;
}

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Depth Buffer Alpha Threshold" forKey:@"name"];
	return at;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	GLfloat oldThreshold;
	GLint   oldFunction;
	GLboolean alphaTestEnabled;
	
	CGLContextObj cgl_ctx = [context CGLContextObj];
	
	glGetFloatv(GL_ALPHA_TEST_REF,&oldThreshold);
	glGetIntegerv(GL_ALPHA_TEST_FUNC, &oldFunction);
	
	glAlphaFunc(GL_GREATER, [inputThreshold doubleValue]);
	alphaTestEnabled = glIsEnabled(GL_ALPHA_TEST);
	if(!alphaTestEnabled)
		glEnable(GL_ALPHA_TEST);
	
	[self executeSubpatches:time arguments:arguments];

	if(!alphaTestEnabled)
		glDisable(GL_ALPHA_TEST);
	glAlphaFunc(oldFunction, oldThreshold);

	return YES;
}

@end
