#import <OpenGL/CGLMacro.h>
#import <OpenGL/gl.h>
#import <OpenGL/OpenGL.h>
#import "GLGridRenderer.h"
#import "QCStructure.h"

@implementation GLGridRenderer : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 1;
}
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}
+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	
	if(z)
	{
		/*vertexData = NULL;
		colorData = NULL;
		texData = NULL;
		currentWidth = 0;
		currentHeight = 0;*/
		[inputWireFrame setMaxIndexValue:2];
	}
	
	return z;
}

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Grid Renderer" forKey:@"name"];
	return at;
}

- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}

/*GLfloat S [4] =
{ 1.0, 0.0, 0.0, +0.5 };


GLfloat T[14] = 
{ 0.0, 1.0, 0.0, +0.5 };*/

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	unsigned int x, y;
	//unsigned int index = 0;
	unsigned int width, height;
	QCStructure *mesh = [inputStructure structureValue];
	QCStructure *vertex;
	
	if(mesh == nil)
		return YES;
		
	width = [[mesh memberForKey:@"width"] intValue];
	height = [[mesh memberForKey:@"height"] intValue];
	
	if(width <= 0 || height <= 0)
		return YES;
	
	// if the mesh is different, we need to update our arrays.
#if 0 // high poly-count mesh optimization (incomplete)
	if(currentStructure != mesh)
	{
		// sizes changed, need to reallocate
		if(width != currentWidth || height != currentHeight)
		{
			if(vertexData)
				free(vertexData);
			if(colorData)
				free(colorData);
			if(texData)
				free(texData);
			vertexData = (float*)malloc(sizeof(float) * 3 * width * height*4);
			colorData = (float*)malloc(sizeof(float) * 4 * width * height*4);
			texData = (float*)malloc(sizeof(float) * 2 * width * height*4);
		}
		currentWidth = width;
		currentHeight = height;

		for(y=0; y<height; ++y)
			for(x=0; x<width;++x)
			{
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
				colorData[index*4+0] = [[vertex memberForKey:@"r"] floatValue];
				colorData[index*4+1] = [[vertex memberForKey:@"g"] floatValue];
				colorData[index*4+2] = [[vertex memberForKey:@"b"] floatValue];
				colorData[index*4+3] = [[vertex memberForKey:@"a"] floatValue];
				texData[index*2+0] = [[vertex memberForKey:@"u"] floatValue];
				texData[index*2+1] = [[vertex memberForKey:@"v"] floatValue];
				vertexData[index*3+0] = [[vertex memberForKey:@"x"] floatValue];
				vertexData[index*3+1] = [[vertex memberForKey:@"y"] floatValue];
				vertexData[index*3+2] = [[vertex memberForKey:@"z"] floatValue];
				++index;
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				colorData[index*4+0] = [[vertex memberForKey:@"r"] floatValue];
				colorData[index*4+1] = [[vertex memberForKey:@"g"] floatValue];
				colorData[index*4+2] = [[vertex memberForKey:@"b"] floatValue];
				colorData[index*4+3] = [[vertex memberForKey:@"a"] floatValue];
				texData[index*2+0] = [[vertex memberForKey:@"u"] floatValue];
				texData[index*2+1] = [[vertex memberForKey:@"v"] floatValue];
				vertexData[index*3+0] = [[vertex memberForKey:@"x"] floatValue];
				vertexData[index*3+1] = [[vertex memberForKey:@"y"] floatValue];
				vertexData[index*3+2] = [[vertex memberForKey:@"z"] floatValue];
				++index;
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
				colorData[index*4+0] = [[vertex memberForKey:@"r"] floatValue];
				colorData[index*4+1] = [[vertex memberForKey:@"g"] floatValue];
				colorData[index*4+2] = [[vertex memberForKey:@"b"] floatValue];
				colorData[index*4+3] = [[vertex memberForKey:@"a"] floatValue];
				texData[index*2+0] = [[vertex memberForKey:@"u"] floatValue];
				texData[index*2+1] = [[vertex memberForKey:@"v"] floatValue];
				vertexData[index*3+0] = [[vertex memberForKey:@"x"] floatValue];
				vertexData[index*3+1] = [[vertex memberForKey:@"y"] floatValue];
				vertexData[index*3+2] = [[vertex memberForKey:@"z"] floatValue];
				++index;
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				colorData[index*4+0] = [[vertex memberForKey:@"r"] floatValue];
				colorData[index*4+1] = [[vertex memberForKey:@"g"] floatValue];
				colorData[index*4+2] = [[vertex memberForKey:@"b"] floatValue];
				colorData[index*4+3] = [[vertex memberForKey:@"a"] floatValue];
				texData[index*2+0] = [[vertex memberForKey:@"u"] floatValue];
				texData[index*2+1] = [[vertex memberForKey:@"v"] floatValue];
				vertexData[index*3+0] = [[vertex memberForKey:@"x"] floatValue];
				vertexData[index*3+1] = [[vertex memberForKey:@"y"] floatValue];
				vertexData[index*3+2] = [[vertex memberForKey:@"z"] floatValue];
				++index;
			}
	}
#endif
	CGLContextObj cgl_ctx = [context CGLContextObj];
	//CGLSetCurrentContext(ctxt);
	
	[inputImage setOnOpenGLContext: context];
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
	
	glBegin(GL_QUADS/*_STRIP*/);
#if 0	// high poly-count grid optimization (incomplete, should use display lists or VBOs)
	for(index = 0;index<width*height*4;++index)
	{
		glColor4f(colorData[index*4+0], colorData[index*4+1], colorData[index*4+2], colorData[index*4+3]);
		glTexCoord2f(texData[index*2+0], texData[index*2+1]);
		glVertex3f(vertexData[index*3+0], vertexData[index*3+1], vertexData[index*3+2]);
	}
#endif

	for(y = 0; y < height; ++y)
	{
		//glBegin(GL_LINE_STRIP);
		for(x = 0; x < width; ++x)
		{
			/*glColor4f(colorData[index*4+0], colorData[index*4+1], colorData[index*4+2], colorData[index*4+3]);
			glTexCoord2f(texData[index*2+0], texData[index*2+1]);
			glVertex3f(vertexData[index*3+0], vertexData[index*3+0], vertexData[index*3+0]);

			glColor4f(colorData[index*4+0], colorData[index*4+1], colorData[index*4+2], colorData[index*4+3]);
			glTexCoord2f(texData[index*2+0], texData[index*2+1]);
			glVertex3f(vertexData[index*3+0], vertexData[index*3+0], vertexData[index*3+0]);

			glColor4f(colorData[index*4+0], colorData[index*4+1], colorData[index*4+2], colorData[index*4+3]);
			glTexCoord2f(texData[index*2+0], texData[index*2+1]);
			glVertex3f(vertexData[index*3+0], vertexData[index*3+0], vertexData[index*3+0]);

			glColor4f(colorData[index*4+0], colorData[index*4+1], colorData[index*4+2], colorData[index*4+3]);
			glTexCoord2f(texData[index*2+0], texData[index*2+1]);
			glVertex3f(vertexData[index*3+0], vertexData[index*3+0], vertexData[index*3+0]);*/

			
			/*glColor4fv(colorData+4 * (y*(width+1)+x));
			glTexCoord2fv(texData+2 * (y*(width+1)+x));
			glVertex3fv(vertexData+3 * (y*(width+1)+x));

			glColor4fv(colorData+4 * (y*(width+1)+x+1));
			glTexCoord2fv(texData+2 * (y*(width+1)+x+1));
			glVertex3fv(vertexData+3 * (y*(width+1)+x+1));

			glColor4fv(colorData+4 * ((y+1)*(width+1)+x+1));
			glTexCoord2fv(texData+2 * ((y+1)*(width+1)+x+1));
			glVertex3fv(vertexData+3 * ((y+1)*(width+1)+x+1));

			glColor4fv(colorData+4 * ((y+1)*(width+1)+x));
			glTexCoord2fv(texData+2 * ((y+1)*(width+1)+x));
			glVertex3fv(vertexData+3 * ((y+1)*(width+1)+x));*/

			/* top, bottom, for each column. first index is 1+x (stupid structure constructor), then width+1+x, */
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glTexCoord2f([[vertex memberForKey:@"u"] floatValue],[[vertex memberForKey:@"v"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
				
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glTexCoord2f([[vertex memberForKey:@"u"] floatValue],[[vertex memberForKey:@"v"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
				
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glTexCoord2f([[vertex memberForKey:@"u"] floatValue],[[vertex memberForKey:@"v"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
		
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glTexCoord2f([[vertex memberForKey:@"u"] floatValue],[[vertex memberForKey:@"v"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
		}
	}
	glEnd();
	
	[inputImage unsetOnOpenGLContext: context];
	
	if([inputWireFrame indexValue] == 1)	// triangles
	{
		for(y = 0; y < height; ++y)
		{
			for(x = 0; x < width; ++x)
			{
				// same as above, but start at 3, and end at 2 (2 extra points) to complete the wireframe
				/* top, bottom, for each columb. first index is 1+x (stupid structure constructor), then width+1+x, */
				glBegin(GL_LINE_STRIP);
				glColor4f(1.0,1.0,1.0,1.0);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				glEnd();
			}
		}
	}
	else if ([inputWireFrame indexValue] == 2)	// quad
	{
		for(y = 0; y < height; ++y)
		{
			for(x = 0; x < width; ++x)
			{
				glBegin(GL_LINE_STRIP);
				glColor4f(1.0,1.0,1.0,1.0);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);

				/*vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);*/
				glEnd();
			}
		}
	}

	if([inputHighlightSelection booleanValue] == TRUE)
	{
		GLfloat origPointSize;
		glGetFloatv(GL_POINT_SIZE,&origPointSize);
		glPointSize(8.0);
		glBegin(GL_POINTS);
		glColor4f(1.0,0.1,0.1,1.0);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",[inputSelection indexValue]+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
		glEnd();
		
		glPointSize(origPointSize);
	}

	//currentStructure = mesh;

	return YES;
}

@end
