#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCIndexPort.h"
#import "QCColorPort.h"
#import "QCOpenGLPort_Blending.h"
#import "QCOpenGLPort_ZBuffer.h"

//#import "QCGLPorts.h"

@interface GLLinePatch : QCPatch
{
	QCNumberPort	*inputSize;

	QCIndexPort		*inputPattern;
	QCIndexPort		*inputRepeatCount;
	
	QCNumberPort	*inputX1;
	QCNumberPort	*inputY1;
	QCNumberPort	*inputZ1;
	QCColorPort		*inputColor1;

	QCNumberPort	*inputX2;
	QCNumberPort	*inputY2;
	QCNumberPort	*inputZ2;
	QCColorPort		*inputColor2;
	
	//QCOpenGLPort_Image	*inputImage;
	
	/* special control ports.  we don't need to handle them in the xml file. */
	QCOpenGLPort_Blending	*inputBlending;
	QCOpenGLPort_ZBuffer	*inputDepth;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end