#import <OpenGL/gl.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/CGLMacro.h>

#import "GLMultMatrixPatch.h"


@implementation GLMultMatrixPatch : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 1;
}
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return YES;
}
+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	if(z)
	{
		[input00 setDoubleValue:1.0];
		[input11 setDoubleValue:1.0];
		[input22 setDoubleValue:1.0];
		[input33 setDoubleValue:1.0];
	}
	return z;
}
- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Matrix" forKey:@"name"];
	return at;
}


- (id)setup:(QCOpenGLContext *)context
{
	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{
}


- (void)enable:(QCOpenGLContext *)context
{
}
- (void)disable:(QCOpenGLContext *)context
{
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	CGLContextObj cgl_ctx = [context CGLContextObj];
	//CGLContextObj old_ctx = CGLGetCurrentContext();
	//CGLSetCurrentContext([context CGLContextObj]);

	double m[16] =
	{
		[input00 doubleValue],
		[input01 doubleValue],
		[input02 doubleValue],
		[input03 doubleValue],

		[input10 doubleValue],
		[input11 doubleValue],
		[input12 doubleValue],
		[input13 doubleValue],

		[input20 doubleValue],
		[input21 doubleValue],
		[input22 doubleValue],
		[input23 doubleValue],

		[input30 doubleValue],
		[input31 doubleValue],
		[input32 doubleValue],
		[input33 doubleValue],
	};

	GLint oldMatrixMode;
	glGetIntegerv(GL_MATRIX_MODE,&oldMatrixMode);
	glMatrixMode(GL_MODELVIEW);
	{
		glPushMatrix();
		{
			glMultMatrixd(m);
			[self executeSubpatches:time arguments:arguments];
		}
		glPopMatrix();
	}
	glMatrixMode(oldMatrixMode);

	//CGLSetCurrentContext(old_ctx);

	return YES;
}

@end
