#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCIndexPort.h"
#import "QCNumberPort.h"

@interface GLPolygonModePatch : QCPatch
{
	QCIndexPort		*inputFrontPolygonMode;	// Points, Lines, or Fills
	QCIndexPort		*inputBackPolygonMode;	// Points, Lines, or Fills

	QCNumberPort	*inputWidth;	// line width, for line mode
	QCNumberPort	*inputSize;		// point size, for point mode
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
//- (BOOL)executeSubpatches:(double)time arguments:(NSDictionary*)arguments;
@end