#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCStructure.h"
#import "QCStructurePort.h"
#import "QCIndexPort.h"
#import "QCGLPort_Image.h"

@interface GLGridRenderer : QCPatch
{
	QCStructurePort *inputStructure;
	QCIndexPort		*inputWireFrame;
	QCIndexPort		*inputSelection;
	QCBooleanPort	*inputHighlightSelection;
	
	QCGLPort_Image	*inputImage;
	
#if 0	// optimizations for higher density grids.  Not implemented yet.
	QCStructure	*currentStructure;
	unsigned int currentWidth, currentHeight;
	float *vertexData;	// x, y, z data
	float *colorData;	// r, g, b, a data
	float *texData;	// u, v data
#endif
}

- (id)initWithIdentifier:(id)fp8;

//- (id)setup:(QCOpenGLContext *)context;
//- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end