#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCColorPort.h"
#import "QCGLPort_Blending.h"
#import "QCGLPort_ZBuffer.h"

//#import "QCGLPorts.h"

@interface GLLinePatch : QCPatch
{
	QCNumberPort	*inputSize;

	QCNumberPort	*inputX1;
	QCNumberPort	*inputY1;
	QCNumberPort	*inputZ1;
	QCColorPort		*inputColor1;

	QCNumberPort	*inputX2;
	QCNumberPort	*inputY2;
	QCNumberPort	*inputZ2;
	QCColorPort		*inputColor2;
	
	/* special control ports.  we don't need to handle them in the xml file. */
	QCGLPort_Blending	*inputBlending;
	QCGLPort_ZBuffer	*inputDepth;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end