#import <OpenGL/CGLMacro.h>
#import "GLLogicOp.h"

GLint modes[16] = 
{
	GL_CLEAR,
	GL_SET,
	GL_COPY,
	GL_COPY_INVERTED,
	GL_NOOP,
	GL_INVERT,
	GL_AND,
	GL_NAND,
	GL_OR,
	GL_NOR,
	GL_XOR,
	GL_EQUIV,
	GL_AND_REVERSE,
	GL_AND_INVERTED,
	GL_OR_REVERSE,
	GL_OR_INVERTED
};

@implementation GLLogicOp : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 1;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return YES;
}

+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputMode setMaxIndexValue:15];
	[inputMode setIndexValue:2];

	return z;
}

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Logic Op" forKey:@"name"];
	return at;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	CGLContextObj cgl_ctx = [context CGLContextObj];
	GLint oldLogicOp;
	
	glGetIntegerv(GL_LOGIC_OP_MODE,&oldLogicOp);
	glEnable(GL_COLOR_LOGIC_OP);
	
	glLogicOp(modes[ [inputMode indexValue] ]);
	
	[self executeSubpatches:time arguments:arguments];
	
	glDisable(GL_COLOR_LOGIC_OP);
	glLogicOp(oldLogicOp);
	

	return YES;
}

@end
