#import <OpenGL/CGLMacro.h>
#import "GLOrtho.h"


@implementation GLOrtho : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 1;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return YES;
}

+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputLeft setDoubleValue:-1.];
	[inputRight setDoubleValue:+1.];
	[inputBottom setDoubleValue:+4./3];
	[inputTop setDoubleValue:-4./3];
	[inputNear setDoubleValue:0.];
	[inputFar setDoubleValue:100.];

	return z;
}

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Ortho" forKey:@"name"];
	return at;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	CGLContextObj cgl_ctx = [context CGLContextObj];

	double modifiedMatrix[16],t1,t2,t3;
	GLint oldMatrixMode,i;
	
	glGetIntegerv(GL_MATRIX_MODE,&oldMatrixMode);
	//glGetDoublev(GL_MODELVIEW_MATRIX,oldMatrix);
	
	for(i=1;i<15;++i)
		modifiedMatrix[i] = 0.0;//oldMatrix[i];
	
	// @@@ The math is right ...  the output is wrong though.  need to investigate more.
	
	t1 = ([inputRight doubleValue] + [inputLeft doubleValue]) / ([inputRight doubleValue] - [inputLeft doubleValue]);
	t2 = ([inputTop doubleValue] + [inputBottom doubleValue]) / ([inputTop doubleValue] - [inputBottom doubleValue]);
	t3 = ([inputFar doubleValue] + [inputNear doubleValue]) / ([inputFar doubleValue] - [inputNear doubleValue]);
	modifiedMatrix[ 0] = 2. / ([inputRight doubleValue] - [inputLeft doubleValue]);
	modifiedMatrix[ 3] = t1;
	modifiedMatrix[ 5] = 2. / ([inputTop doubleValue] - [inputBottom doubleValue]);
	modifiedMatrix[ 7] = t2;
	modifiedMatrix[10] = 2. / ([inputFar doubleValue] - [inputNear doubleValue]);
	modifiedMatrix[11] = t3;
	modifiedMatrix[15] = 1.0;
	
	//glMatrixMode(GL_MODELVIEW);
	//glPushMatrix();
	//glLoadIdentity();
	
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glLoadMatrixd(modifiedMatrix);
		[self executeSubpatches:time arguments:arguments];
		glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
		
	glMatrixMode(oldMatrixMode);
	

	return YES;
}

@end
