#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCColorPort.h"

#import "QCGLPort_Blending.h"
#import "QCGLPort_Color.h"
#import "QCGLPort_Culling.h"
#import "QCGLPort_Image.h"
#import "QCGLPort_ZBuffer.h"


@interface GLPointPatch : QCPatch
{
	QCNumberPort	*inputSize;
	QCNumberPort	*inputX;
	QCNumberPort	*inputY;
	QCNumberPort	*inputZ;
	
	QCBooleanPort	*inputAttenuate;
	
	QCColorPort		*inputColor;
	
	/* special control ports.  we don't need to handle them in the xml file. */
	QCGLPort_Image		*inputImage;
	QCGLPort_Blending	*inputBlending;
	QCGLPort_ZBuffer	*inputDepth;
	
	//id imageManager;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end