#import <OpenGL/gl.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/CGLMacro.h>

#import "GLPolygonModePatch.h"


@implementation GLPolygonModePatch : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 1;	// renders stuff
}
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return YES;
}
+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	
	if(z)
	{
		[inputFrontPolygonMode setMaxIndexValue: 2];
		[inputBackPolygonMode setMaxIndexValue:  2];
		[inputSize setMinDoubleValue:  0.4];
		[inputWidth setMinDoubleValue: 0.4];
		[inputSize setDoubleValue:  1.0];
		[inputWidth setDoubleValue: 1.0];
	}

	return z;
}


- (id)setup:(QCOpenGLContext *)context
{


	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	GLint origPolygonMode[2];
	GLfloat origLineWidth;
	GLfloat origPointSize;
	
	CGLContextObj cgl_ctx = [context CGLContextObj];
	//CGLContextObj old_ctx = CGLGetCurrentContext();
	//CGLSetCurrentContext([context CGLContextObj]);
	//[self beginLocalContext];
	
	// store the original values
	glGetIntegerv(GL_POLYGON_MODE,origPolygonMode);
	glGetFloatv(GL_LINE_WIDTH,&origLineWidth);
	glGetFloatv(GL_POINT_SIZE, &origPointSize);
	//NSLog(@"params: %i, %i",params[0], params[1]);
	
	switch([inputFrontPolygonMode indexValue])
	{
		default:
		case 0:	// filled
			glPolygonMode(GL_FRONT, GL_FILL);
			break;
		case 1:	// wireframe
			glPolygonMode(GL_FRONT, GL_LINE);
			break;
		case 2:	// points
			glPolygonMode(GL_FRONT, GL_POINT);
			break;
	}
	switch([inputBackPolygonMode indexValue])
	{
		default:
		case 0:	// filled
			glPolygonMode(GL_BACK, GL_FILL);
			break;
		case 1:	// wireframe
			glPolygonMode(GL_BACK, GL_LINE);
			break;
		case 2:	// points
			glPolygonMode(GL_BACK, GL_POINT);
			break;
	}
	
	glLineWidth([inputWidth doubleValue]);
	glPointSize([inputSize doubleValue]);
	
	[self executeSubpatches:time arguments:arguments];
	
	// restore the previous mode
	glPolygonMode(GL_FRONT,origPolygonMode[0]);
	glPolygonMode(GL_BACK,origPolygonMode[1]);
	glLineWidth(origLineWidth);
	glPointSize(origPointSize);

	//[self endLocalContext];
	//CGLSetCurrentContext(old_ctx);

	return YES;
}

@end
