#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCNumberPort.h"
#import "QCIndexPort.h"
#import "QCColorPort.h"

@interface GLSplinePatch : QCPatch
{
	QCIndexPort		*inputSubdivisions;
	QCNumberPort	*inputTension;
	QCNumberPort	*inputWidth;
	QCBooleanPort	*inputShowPoints;
	QCNumberPort	*inputPointSize;
	QCBooleanPort	*inputUsePointColor;
	QCColorPort		*inputPointColor;
	
	QCNumberPort	**xArray;
	QCNumberPort	**yArray;
	QCNumberPort	**zArray;
	QCColorPort		**colorArray;
	
	unsigned int controlPoints;
	float *ptsx, *ptsy, *ptsz;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;

- (NSDictionary*)state;
- (BOOL)setState:(NSDictionary*)state;

- (void)addPoint;
- (void)removePoint;
@end