#import "GLTools_TigerPrincipal.h"

#import "GLContextInfoPatch.h"
#import "GLMultMatrixPatch.h"
#import "GLPolygonModePatch.h"
#import "GLFieldOfViewPatch.h"
#import "GLDepthBufferAlphaThreshold.h"

#import "GLPointPatch.h"
#import "GLLinePatch.h"
#import "GLSplinePatch.h"
#import "GLTrianglePatch.h"
#import "GLQuadPatch.h"

#import "GLGridPatch.h"
#import "GLGridRenderer.h"
#import "GLLogicOp.h"

@implementation GLTools_TigerPlugin
+ (void)registerNodesWithManager:(GFNodeManager*)manager
{
	//NSLog(@"stuff!");
	// each pattern checks to see if it's already registered.  Follow the pattern with additional patches.
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLContextInfoPatch class])] == FALSE )
		[manager registerNodeWithClass:[GLContextInfoPatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLMultMatrixPatch class])] == FALSE )
		[manager registerNodeWithClass:[GLMultMatrixPatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLPolygonModePatch class])] == FALSE )
		[manager registerNodeWithClass:[GLPolygonModePatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLDepthBufferAlphaThreshold class])] == FALSE )
		[manager registerNodeWithClass:[GLDepthBufferAlphaThreshold class]];

	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLPointPatch class])] == FALSE )
		[manager registerNodeWithClass:[GLPointPatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLLinePatch class])] == FALSE )
		[manager registerNodeWithClass:[GLLinePatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLSplinePatch class])] == FALSE )
		[manager registerNodeWithClass:[GLSplinePatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLTrianglePatch class])] == FALSE )
		[manager registerNodeWithClass:[GLTrianglePatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLQuadPatch class])] == FALSE )
		[manager registerNodeWithClass:[GLQuadPatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLFieldOfViewPatch class])] == FALSE )
		[manager registerNodeWithClass:[GLFieldOfViewPatch class]];

	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLGridPatch class])] == FALSE )
		[manager registerNodeWithClass:[GLGridPatch class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLGridRenderer class])] == FALSE )
		[manager registerNodeWithClass:[GLGridRenderer class]];
	if( [manager isNodeRegisteredWithName: NSStringFromClass([GLLogicOp class])] == FALSE )
		[manager registerNodeWithClass:[GLLogicOp class]];

}
@end
